/* -*- C++ -*-
 * $Id: flvstyle.cc,v 1.5 2006/12/22 17:39:12 jeremy_henty Exp $
 */

#include "../fltk.h"
#include "../flwidget.h"
#include "flvstyle.h"
#include "../flenum.h"

#define DEF_FLVB_CONST_NUM(c) \
  DEF_MODULE_CONST("VB_"#c,INT2NUM(FLVB_##c))

#define FN_ST_GETSET_WIDGET(klass,method) \
VALUE rb_FL##klass##_##method(int argc, VALUE argv[], VALUE self){ \
  RBFL##klass *obj; \
  VALUE arg1; \
  Data_Get_Struct(self,RBFL##klass,obj);\
  switch( rb_scan_args(argc, argv, "01", &arg1) ){ \
  case 0: \
    return rb_fltk_objmap_aref((Fl_Widget*)(obj->method())); \
  case 1: \
    obj->method((rb_to_fl(arg1))); \
    return Qnil; \
  }; \
  return Qnil; \
};


#define FN_ST_GETSET_COLOR(klass,method) \
VALUE rb_FL##klass##_##method(int argc, VALUE argv[], VALUE self){ \
  RBFL##klass *obj; \
  VALUE arg1; \
  Data_Get_Struct(self,RBFL##klass,obj);\
  switch( rb_scan_args(argc, argv, "01", &arg1) ){ \
  case 0: \
    return INT2NUM(obj->method()); \
  case 1: \
    obj->method(VALUE2COLOR(arg1)); \
    break; \
  }; \
  return Qnil; \
};

#define FN_ST_GETSET_INT(klass,method) \
VALUE rb_FL##klass##_##method(int argc, VALUE argv[], VALUE self){ \
  RBFL##klass *obj; \
  VALUE arg1; \
  Data_Get_Struct(self,RBFL##klass,obj);\
  switch( rb_scan_args(argc, argv, "01", &arg1) ){ \
  case 0: \
    return INT2NUM(obj->method()); \
  case 1: \
    obj->method(NUM2INT(arg1)); \
    break; \
  }; \
  return Qnil; \
};

#define FN_ST_GETSET_BOOL(klass,method) \
VALUE rb_FL##klass##_##method(int argc, VALUE argv[], VALUE self){ \
  RBFL##klass *obj; \
  VALUE arg1; \
  Data_Get_Struct(self,RBFL##klass,obj);\
  switch( rb_scan_args(argc, argv, "01", &arg1) ){ \
  case 0: \
    return INT2BOOL(((RBFL##klass*)obj)->method()); \
  case 1: \
    ((RBFL##klass*)obj)->method(BOOL2INT(arg1)); \
    break; \
  }; \
  return Qnil; \
};

#define FN_ST_GET_BOOL(klass,method) \
VALUE rb_FL##klass##_##method(VALUE self){ \
  RBFL##klass *obj; \
  Data_Get_Struct(self,RBFL##klass,obj);\
    return INT2BOOL(((RBFL##klass*)obj)->method()); \
};

#define FN_ST_CALL(klass,method) \
VALUE rb_FL##klass##_##method(VALUE self){ \
  RBFL##klass *obj; \
  Data_Get_Struct(self,RBFL##klass,obj);\
  obj->method(); \
  return Qnil; \
};


VALUE rb_cFLVStyleList;
VALUE rb_cFLVStyle;
VALUE rb_cFLVCStyle;

//static FN_ST_CALL(VStyleList, clear);
//static FN_ST_CALL(VStyleList, compact);
//static FN_ST_CALL(VStyleList, release);
//static FN_GET_WIDGET(VStyleList, current);
//static FN_GET_WIDGET_SET_INT(VStyleList, find);
//static FN_GET_WIDGET(VStyleList, first);

static FN_ST_GETSET_INT(VCStyle, x);
static FN_ST_GETSET_INT(VCStyle, y);

static FN_ST_GET_BOOL(VStyle, all_clear);
static FN_ST_CALL(VStyle, clear_all);
static FN_ST_GET_BOOL(VStyle, all_defined);
static FN_ST_CALL(VStyle, clear_align);
static FN_ST_GET_BOOL(VStyle, align_defined);
static FN_ST_GETSET_COLOR(VStyle, background);
static FN_ST_CALL(VStyle, clear_background);
static FN_ST_GET_BOOL(VStyle, background_defined);
static FN_ST_GETSET_INT(VStyle, border);
static FN_ST_CALL(VStyle, clear_border);
static FN_ST_GET_BOOL(VStyle, left_border);
static FN_ST_GET_BOOL(VStyle, top_border);
static FN_ST_GET_BOOL(VStyle, right_border);
static FN_ST_GET_BOOL(VStyle, bottom_border);
static FN_ST_GET_BOOL(VStyle, inner_left_border);
static FN_ST_GET_BOOL(VStyle, inner_top_border);
static FN_ST_GET_BOOL(VStyle, inner_right_border);
static FN_ST_GET_BOOL(VStyle, inner_bottom_border);
static FN_ST_GETSET_COLOR(VStyle, border_color);
static FN_ST_CALL(VStyle, clear_border_color);
static FN_ST_GET_BOOL(VStyle, border_color_defined);
static FN_ST_GETSET_WIDGET(VStyle, editor);
static FN_ST_CALL(VStyle, clear_editor);
static FN_ST_CALL(VStyle, clear_font);
static FN_ST_GET_BOOL(VStyle, font_defined);
static FN_ST_GETSET_INT(VStyle, font_size);
static FN_ST_CALL(VStyle, clear_font_size);
static FN_ST_GETSET_COLOR(VStyle, foreground);
static FN_ST_CALL(VStyle, clear_foreground);
static FN_ST_GET_BOOL(VStyle, foreground_defined);
static FN_ST_CALL(VStyle, clear_frame);
static FN_ST_GET_BOOL(VStyle, frame_defined);
static FN_ST_GETSET_INT(VStyle, height);
static FN_ST_CALL(VStyle, clear_height);
static FN_ST_GET_BOOL(VStyle, height_defined);
static FN_ST_GETSET_BOOL(VStyle, locked);
static FN_ST_CALL(VStyle, clear_locked);
static FN_ST_GET_BOOL(VStyle, locked_defined);
static FN_ST_GETSET_BOOL(VStyle, resizable);
static FN_ST_CALL(VStyle, clear_resizable);
static FN_ST_GET_BOOL(VStyle, resizable_defined);
static FN_ST_GETSET_INT(VStyle, width);
static FN_ST_CALL(VStyle, clear_width);
static FN_ST_GET_BOOL(VStyle, width_defined);
static FN_ST_GETSET_INT(VStyle, x_margin);
static FN_ST_CALL(VStyle, clear_x_margin);
static FN_ST_GET_BOOL(VStyle, x_margin_defined);
static FN_ST_GETSET_INT(VStyle, y_margin);
static FN_ST_CALL(VStyle, clear_y_margin);
static FN_ST_GET_BOOL(VStyle, y_margin_defined);

static void rb_FLVStyleList_free(Flv_Style_List *s)
{
  if( s ) delete s;
};

static VALUE rb_FLVStyleList_new(VALUE klass, Flv_Style_List *s)
{
  VALUE obj;
  obj = Data_Wrap_Struct(klass, 0, rb_FLVStyleList_free, s);
  return obj;
};

static VALUE rb_FLVStyleList_s_new(int argc, VALUE argv[], VALUE klass)
{
  VALUE obj = Qnil;  /* for new object */

  obj = rb_FLVStyleList_new(klass, new Flv_Style_List());

  rb_obj_call_init(obj, argc, argv);

  return obj;
};

static VALUE rb_FLVStyleList_initialize(int argc, VALUE argv[], VALUE self)
{
  return Qnil;
};

static VALUE rb_FLVStyleList_aref(int argc, VALUE argv[], VALUE self)
{
  Flv_Style_List *sl;
  VALUE obj;
  Data_Get_Struct(self,Flv_Style_List,sl);
  obj = Data_Wrap_Struct(rb_cFLVStyle,0,0,(Flv_Style*) &((*sl)[FIX2INT(argv[0])]));

  return obj;
};


static void rb_FLVCStyle_free(Flv_CStyle *s)
{
  if( s ) delete s;
};

static VALUE rb_FLVCStyle_new(VALUE klass, Flv_CStyle *s)
{
  VALUE obj;
  obj = Data_Wrap_Struct(klass, 0, rb_FLVCStyle_free, s);
  return obj;
};

static VALUE rb_FLVCStyle_s_new(int argc, VALUE argv[], VALUE klass)
{
  VALUE obj = Qnil;  /* for new object */

  obj = rb_FLVCStyle_new(klass, new Flv_CStyle());

  rb_obj_call_init(obj, argc, argv);

  return obj;
};

static VALUE rb_FLVCStyle_initialize(int argc, VALUE argv[], VALUE self)
{
  return Qnil;
};


static void rb_FLVStyle_free(Flv_Style *s)
{
  if( s ) delete s;
};

static VALUE rb_FLVStyle_new(VALUE klass, Flv_Style *s)
{
  VALUE obj;
  obj = Data_Wrap_Struct(klass, 0, rb_FLVStyle_free, s);
  return obj;
};

static VALUE rb_FLVStyle_s_new(int argc, VALUE argv[], VALUE klass)
{
  VALUE rs;   /* requested size */
  VALUE obj = Qnil;  /* for new object */

  switch( rb_scan_args(argc, argv, "01", &rs) ){
  case 0:
    obj = rb_FLVStyle_new(klass, new Flv_Style());
    break;
  case 1:
    obj = rb_FLVStyle_new(klass, new Flv_Style(NUM2INT(rs)));
    break;
  }

  rb_obj_call_init(obj, argc, argv);

  return obj;
};

static VALUE rb_FLVStyle_initialize(int argc, VALUE argv[], VALUE self)
{
  return Qnil;
};

static VALUE rb_FLVStyle_align(int argc, VALUE argv[], VALUE self)
{
  Flv_Style *s;
  VALUE data;

  Data_Get_Struct(self,Flv_Style,s);

  switch( rb_scan_args(argc, argv, "01", &data) ){
  case 0:
    return INT2FIX(s->align());
  case 1:
    return INT2FIX(s->align((Fl_Align)FIX2INT(data)));
  };
  return Qnil;
};

static VALUE rb_FLVStyle_font(int argc, VALUE argv[], VALUE self)
{
  Flv_Style *s;
  VALUE data;

  Data_Get_Struct(self,Flv_Style,s);

  switch( rb_scan_args(argc, argv, "01", &data) ){
  case 0:
    return INT2FIX(s->font());
  case 1:
    return INT2FIX(s->font((Fl_Font)FIX2INT(data)));
  };
  return Qnil;
};

static VALUE rb_FLVStyle_frame(int argc, VALUE argv[], VALUE self)
{
  Flv_Style *s;
  VALUE data;

  Data_Get_Struct(self,Flv_Style,s);

  switch( rb_scan_args(argc, argv, "01", &data) ){
  case 0:
    return INT2FIX(s->frame());
  case 1:
    return INT2FIX(s->frame((Fl_Boxtype)FIX2INT(data)));
  };
  return Qnil;
};

extern "C" void
Init_flvstyle(){

  rb_cFLVStyle = rb_define_class_under(rb_mFLTK, "VStyle", rb_cObject);
  DEF_S_METHOD(VStyle,new,-1);
  DEF_INIT_METHOD(VStyle);
  DEF_METHOD(VStyle, all_clear, 0);
  DEF_METHOD(VStyle, clear_all, 0);
  DEF_METHOD(VStyle, all_defined,0);
  DEF_METHOD(VStyle, align,-1);
  DEF_METHOD(VStyle, clear_align,0);
  DEF_METHOD(VStyle, align_defined,0);
  DEF_METHOD(VStyle, background,-1);
  DEF_METHOD(VStyle, clear_background,0);
  DEF_METHOD(VStyle, background_defined,0);
  DEF_METHOD(VStyle, border,-1);
  DEF_METHOD(VStyle, clear_border,0);
  DEF_METHOD(VStyle, left_border,0);
  DEF_METHOD(VStyle, top_border,0);
  DEF_METHOD(VStyle, right_border,0);
  DEF_METHOD(VStyle, bottom_border,0);
  DEF_METHOD(VStyle, inner_left_border,0);
  DEF_METHOD(VStyle, inner_top_border,0);
  DEF_METHOD(VStyle, inner_right_border,0);
  DEF_METHOD(VStyle, inner_bottom_border,0);
  DEF_METHOD(VStyle, border_color,-1);
  DEF_METHOD(VStyle, clear_border_color,0);
  DEF_METHOD(VStyle, border_color_defined,0);
  DEF_METHOD(VStyle, editor,-1);
  DEF_METHOD(VStyle, clear_editor,0);
  DEF_METHOD(VStyle, clear_font,0);
  DEF_METHOD(VStyle, font,-1);
  DEF_METHOD(VStyle, font_defined,0);
  DEF_METHOD(VStyle, font_size,-1);
  DEF_METHOD(VStyle, clear_font_size,0);
  DEF_METHOD(VStyle, foreground,-1);
  DEF_METHOD(VStyle, clear_foreground,0);
  DEF_METHOD(VStyle, foreground_defined,0);
  DEF_METHOD(VStyle, frame,-1);
  DEF_METHOD(VStyle, clear_frame,0);
  DEF_METHOD(VStyle, frame_defined,0);
  DEF_METHOD(VStyle, height,-1);
  DEF_METHOD(VStyle, clear_height,0);
  DEF_METHOD(VStyle, height_defined,0);
  DEF_METHOD(VStyle, locked,-1);
  DEF_METHOD(VStyle, clear_locked,0);
  DEF_METHOD(VStyle, locked_defined,0);
  DEF_METHOD(VStyle, resizable,-1);
  DEF_METHOD(VStyle, clear_resizable,0);
  DEF_METHOD(VStyle, resizable_defined,0);
  DEF_METHOD(VStyle, width,-1);
  DEF_METHOD(VStyle, clear_width,0);
  DEF_METHOD(VStyle, width_defined,0);
  DEF_METHOD(VStyle, x_margin,-1);
  DEF_METHOD(VStyle, clear_x_margin,0);
  DEF_METHOD(VStyle, x_margin_defined,0);
  DEF_METHOD(VStyle, y_margin,-1);
  DEF_METHOD(VStyle, clear_y_margin,0);
  DEF_METHOD(VStyle, y_margin_defined,0);

  rb_cFLVStyleList = rb_define_class_under(rb_mFLTK, "VStyleList", rb_cObject);
  DEF_S_METHOD(VStyleList,new,-1);
  DEF_INIT_METHOD(VStyleList);
  rb_define_method(rb_cFLVStyleList, "[]", RUBY_METHOD_FUNC(rb_FLVStyleList_aref), -1);
//  DEF_METHOD(VStyleList, clear,0);
//  DEF_METHOD(VStyleList, compact,0);
//  DEF_METHOD(VStyleList, release,0);
//  DEF_METHOD(VStyleList, current,0);
//  DEF_METHOD(VStyleList, find,-1);
//  DEF_METHOD(VStyleList, first,0);

  rb_cFLVCStyle = rb_define_class_under(rb_mFLTK, "VCStyle", rb_cFLVStyle);
  DEF_S_METHOD(VCStyle,new,-1);
  DEF_INIT_METHOD(VCStyle);
  DEF_METHOD(VCStyle, x, -1);
  DEF_METHOD(VCStyle, y, -1);

  DEF_FLVB_CONST_NUM(NONE);
  DEF_FLVB_CONST_NUM(LEFT);
  DEF_FLVB_CONST_NUM(TOP);
  DEF_FLVB_CONST_NUM(RIGHT);
  DEF_FLVB_CONST_NUM(BOTTOM);
  DEF_FLVB_CONST_NUM(INNER_LEFT);
  DEF_FLVB_CONST_NUM(INNER_TOP);
  DEF_FLVB_CONST_NUM(INNER_RIGHT);
  DEF_FLVB_CONST_NUM(INNER_BOTTOM);
  DEF_FLVB_CONST_NUM(OUTER_VERTICALS);
  DEF_FLVB_CONST_NUM(OUTER_HORIZONTALS);
  DEF_FLVB_CONST_NUM(OUTER_ALL);
  DEF_FLVB_CONST_NUM(INNER_VERTICALS);
  DEF_FLVB_CONST_NUM(INNER_HORIZONTALS);
  DEF_FLVB_CONST_NUM(INNER_ALL);
  DEF_FLVB_CONST_NUM(VERTICALS);
  DEF_FLVB_CONST_NUM(HORIZONTALS);
  DEF_FLVB_CONST_NUM(ALL);
  DEF_FLVB_CONST_NUM(LEFTS);
  DEF_FLVB_CONST_NUM(TOPS);
  DEF_FLVB_CONST_NUM(RIGHTS);
  DEF_FLVB_CONST_NUM(BOTTOMS);
}
