# $Id: events.rb,v 1.6 2006/12/31 11:58:24 jeremy_henty Exp $

# credit: Kerepesi Norbert 

require 'fltk'

class MyWin < FLTK::DoubleWindow
  def initialize(*args)
    super(*args){|win|
      FLTK::Pack.new(win.w/2,win.h){|pk2|
        pk2.packtype(FLTK::VERTICAL)
        @ei1 = FLTK::Box.new(0,50)
        @ei1.box(FLTK::FLAT_BOX)
        @ei2 = FLTK::Box.new(0,50)
        @ei2.box(FLTK::FLAT_BOX)
        @btc = FLTK::Box.new(0,30)
        @eic = FLTK::Box.new(0,30)
        @et = FLTK::Box.new(0,30)
        @el = FLTK::Box.new(0,30)
      }
      FLTK::Group.new(win.w/2,0,win.w/2,win.h){|gp1|
        gp1.box(FLTK::ENGRAVED_BOX)
        FLTK::Pack.new(gp1.x+4,20,gp1.w-8,gp1.h-24){|pk3|
          pk3.packtype(FLTK::VERTICAL)
          pk3.box(FLTK::PLASTIC_DOWN_FRAME)
          pk3.label("states by event_state")
          pk3.labeltype(FLTK::SHADOW_LABEL)
          pk3.align(FLTK::ALIGN_TOP_LEFT)
          @est = [["SHIFT",FLTK::SHIFT],
                  ["CAPS_LOCK",FLTK::CAPS_LOCK],
                  ["CTRL",FLTK::CTRL],
                  ["ALT",FLTK::ALT],
                  ["NUM_LOCK",FLTK::NUM_LOCK],
                  ["META",FLTK::META],
                  ["SCROLL_LOCK",FLTK::SCROLL_LOCK],
                  ["BUTTON1",FLTK::BUTTON1],
                  ["BUTTON2",FLTK::BUTTON2],
                  ["BUTTON3",FLTK::BUTTON3],
                  ["BUTTONS",FLTK::BUTTONS]
                 ]
          @est.collect!{|e|
            [FLTK::Box.new(0,30),e[0],e[1]]
          }
        }
      }
      yield(win) if block_given?
    }
  end

  def handle(code)
    return 0 if code.zero?
    @eic.label("event_is_click:" +
               (FLTK.event_is_click ?
                "TRUE" : "false"))

    @et.label(sprintf("event_text:\"%s\"",
                      FLTK.event_text))
    @el.label(sprintf("event_length: %i",
                      FLTK.event_length))

    @est.size.times{|i|
      @est[i][0].label(sprintf("%s state: %s",
                               @est[i][1],
                               (FLTK.event_state(@est[i][2]) ?
                                "PRESSED" : "unpressed")))
    }
    case code
    when FLTK::PUSH
      @ei1.label("event_inside by geom\nclicked here: " +
                 (FLTK.event_inside(40,0,@ei1.w-80,@ei1.h) ?
                  "TRUE" : "false"))
      @ei2.label("event_inside by widget\nclicked here: " +
                 (FLTK.event_inside(@ei2) ?
                  "TRUE" : "false"))
      @btc.label(sprintf("button clicks: %i",
                         FLTK.event_clicks)) 
    end
  end
end

MyWin.new(500,360,"event_* funcs test"){|win|
  win.show
}

FLTK.run
