# $Id: light_dark.rb,v 1.2 2006/12/31 11:58:24 jeremy_henty Exp $

# This program is a part of the Ruby/FLTK tests.
# Author:: Jeremy Henty <mailto:jeremy_henty@users.sourceforge.net>
# Copyright:: Copyright (c) 2006 Jeremy Henty 
# License:: LGPL

=begin

Demonstrate FLTK.{lighter,darker}

=end

require 'fltk'

colors =
  [ FLTK::RED,  FLTK::GREEN,   FLTK::BLUE, 
    FLTK::CYAN, FLTK::MAGENTA, FLTK::YELLOW, ]
count = 4

w = (2*count+1)*20
h = colors.size*20
FLTK::Window.new(w,h,"Lighter/Darker"){|win|
  y = 0
  colors.each{|color|
    x = count*20
    box = FLTK::Box.new(x,y,20,20)
    box.box(FLTK::FLAT_BOX)
    box.color(color)
    color_alt = color
    x1 = x 
    count.times{
      x1 -= 20
      color_alt = FLTK.darker(color_alt)
      box = FLTK::Box.new(x1,y,20,20)
      box.box(FLTK::FLAT_BOX)
      box.color(color_alt)
    }
    color_alt = color
    x1 = x
    count.times{
      x1 += 20
      color_alt = FLTK.lighter(color_alt)
      box = FLTK::Box.new(x1,y,20,20)
      box.box(FLTK::FLAT_BOX)
      box.color(color_alt) 
    }
    y += 20
  }
  win.show
}

FLTK.run
